<?php
/*
 * Created on September 5th 2006.
 * 
 * This script is under the MIT license:
 * 
 * Copyright (c) 2006 alias47@hushmail.com
 * Copyright (c) 2009 Michael Tyson <mike@tyson.id.au>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of 
 * this software and associated documentation files (the "Software"), to deal in the Software 
 * without restriction, including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons 
 * to whom the Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all copies 
 * or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
 * OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
 
 //we need this file for parsing our cURL output
 require 'facebook-parse.php';
 
 //first of all we'll need our credentials for logging in; enter them below
 $login_email = "";
 $login_password = "";
 
 //first let's establish the URL's we'll have to hit
 
 //the first URL from which we will collect the cookies given
 $initial_url = 'http://www.facebook.com';
 
 //the URL to which we'll submit credentials and pass on those cookies collected from the
 //initial URL
 $login_url = 'https://login.facebook.com/login.php';
 
 //this is the file where we will keep our cookies, the ones needed for login and access
 //make sure this is chmodded to 755 so it can be written and read from to by the script
 $cookiejar = "cookiejar.txt"; 
 
 //so as not to let Facebook know we are using an automated script to do all this,
 //we will mask ourselves as if we are just a regular browser by sending down an 
 //innocent-looking user-agent string in the headers. 
 //This particular one is just one from a typical Firefox browser.
 $useragent = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.13) Gecko/20060414';
    
 //in case you want to make all this kinda anonymouse, 
 //you can set up Tor and define the proxy url here and whether or not to use it
 $proxy = false; //in this case let's not use a proxy but if you want to just set it to true
 $proxy_url = 'localhost:8118';
 
 //so now we have everything to begin; let's use cURL to get the hash needed from the main
 //page in order to log in successfully
 $ch = curl_init();
 curl_setopt($ch, CURLOPT_URL, $initial_url);
 curl_setopt($ch, CURLOPT_USERAGENT, $useragent);

 //in case Facebook sends a 302 redirection header or such, we here tell cURL to follow it
 //and give it to us if it is found
 curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	
 //here we tell cURL not to display or return us the headers to recieves as they are not 
 //really needed in this case and makes our parsing easier without them
 curl_setopt($ch, CURLOPT_HEADER, 0);
 
 //we do the below only if we enable a proxy or Tor
 if($proxy)
 {
	//we simpley tell cURL to go through a proxy such as the one defined above
	curl_setopt($ch, CURLOPT_PROXY, $proxy_url);	
 }
 
 //we tell cURL to return the reponse it gets from Facebook to a variable rather than just
 //displaying it to the screen, since we don't want to see it each time, only send it down
 //to our parsers for processing
 curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	
 //when we get those initial cookies we need, this is where we will store them.
 //cookies go into the cookie jar. :) in this case that is the file we defined above
 curl_setopt($ch, CURLOPT_COOKIEJAR, $cookiejar);
	
 //this variable will contain the output we get from Facebook which we can throw into
 //one of our parsers for extracting needed variables.
 $initial_data = curl_exec($ch);
 
 $initial_extracted = initial_parse($initial_data);
 
 $challenge = $initial_extracted['challenge'];
 $noerror = $initial_extracted['noerror'];
 
 //now that we have those necessary variables, let's construct the POST request we have to
 //send to log in, some fields we must URL-encode such as the email and password to be safe
 $login_postfields = "challenge=".$challenge.
				"&noerror=".$noerror.
				"&md5pass=".
				"&email=".urlencode($login_email).
				"&pass=".urlencode($login_password);
 
 
 //we now go to the login URL with out credentials. We can simply use the old cURL session
 //since it already has the useragent, followlocation and other settings we need
 curl_setopt($ch, CURLOPT_URL, $login_url);
 curl_setopt($ch, CURLOPT_COOKIE, $cookiejar);
 curl_setopt($ch, CURLOPT_POST, 1);
 curl_setopt($ch, CURLOPT_POSTFIELDS, $login_postfields);
 curl_setopt($ch, CURLOPT_COOKIEJAR, $cookiejar);
 curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
 curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
 
 $raw_data = curl_exec($ch);
  
 //this is function from the facebook-parse file that will create the feed from the data
 //outputted by curl here
 create_feed($raw_data);

 
?>